﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Threading.Tasks;
using MetroDemo.Model;
using Windows.Foundation;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Data;

namespace MetroDemo
{
	partial class MainPage
	{
		private bool _isLoaded;

		public MainPage()
		{
			InitializeComponent();
			Loaded += MainPage_Loaded;
		}

		async void MainPage_Loaded(object sender, RoutedEventArgs e)
		{
			if (_isLoaded)
				return;

			_isLoaded = true;

			var keywordsVector = new ObservableCollection<object>().ToObservableVector<object>();
			KeywordsViewSource.Source = keywordsVector;

			await ImageModel.PopulateKeywords(keywordsVector);
		}

		private void GridViewControl_SelectionChanged(object sender, SelectionChangedEventArgs e)
		{
			var keyword = e.AddedItems.FirstOrDefault() as String;
			if (keyword != null)
			{
				App.ShowImagesPage(keyword);
			}
		}
	}
}
