﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Windows.Data.Xml.Dom;
using Windows.Foundation;
using Windows.UI.Notifications;
using Windows.UI.StartScreen;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Data;

namespace TilesDemo
{
	partial class MainPage
	{
		public MainPage()
		{
			InitializeComponent();
		}

		/// <summary>
		/// Badge demo
		/// </summary>
		private void ButtonBadge_Click(object sender, RoutedEventArgs e)
		{
			XmlDocument badgeXml = BadgeUpdateManager.GetTemplateContent(BadgeTemplateType.BadgeGlyph);
			XmlElement element = (XmlElement)badgeXml.SelectSingleNode("/badge");

			TileContent.Text = badgeXml.GetXml();

			element.SetAttribute("value", "error");
			element.SetAttribute("version", "1");

			var notification = new BadgeNotification(badgeXml);
			BadgeUpdateManager.CreateBadgeUpdaterForApplication().Update(notification);

		}

		/// <summary>
		/// Custom text tile demo
		/// </summary>
		private void ButtonText_Click(object sender, RoutedEventArgs e)
		{
			var tileXml = TileUpdateManager.GetTemplateContent(TileTemplateType.TileWideText05);

			TileContent.Text = tileXml.GetXml();

			var textNode = tileXml.SelectSingleNode("/tile/visual/binding/text[@id='1']");
			var newText = tileXml.CreateTextNode(DateTime.Now.ToString());
			textNode.AppendChild(newText);

			var notification = new TileNotification(tileXml);
			TileUpdateManager.CreateTileUpdaterForApplication().Update(notification);
			TileUpdateManager.CreateTileUpdaterForApplication().EnableNotificationQueue(true);
		}

		/// <summary>
		/// Secondary tile demo
		/// </summary>
		async private void ButtonSecondTile_Click(object sender, RoutedEventArgs e)
		{
			var tile = new SecondaryTile("secondTile", "Second Tile", "Secondary Tile Example",
				"<command line parameter>",
				 TileDisplayAttributes.ShowName,
				 new Uri("ms-resource:images/Logo.png"));

			bool isPinned = await tile.RequestCreateAsync();
		}

		/// <summary>
		/// Clear all 
		/// </summary>
		private void ButtonClear_Click(object sender, RoutedEventArgs e)
		{
			BadgeUpdateManager.CreateBadgeUpdaterForApplication().Clear();
			TileUpdateManager.CreateTileUpdaterForApplication().Clear();
		}
	}
}
